# AbsurdJS

[![Build Status](https://travis-ci.org/krasimir/absurd.svg?branch=master)](https://travis-ci.org/krasimir/absurd)
[![Dependency Status](https://david-dm.org/krasimir/absurd.svg?theme=shields.io)](https://david-dm.org/krasimir/absurd)
[![CDNJS](https://img.shields.io/cdnjs/v/absurd.svg)](https://cdnjs.com/libraries/absurd)

## Overview

Javascript based preprocessor. No new language, no new syntax. Write everything in plain JavaScript.

## Installation

### [Server-side](http://absurdjs.com/pages/installation/#node-js)

	npm install -g absurd

### [Client-side](http://absurdjs.com/pages/installation/#client-side-port)

	<script src="absurd.min.js"></script>

## About

AbsurdJS was started as CSS preprocessor, but later it was expanded to a HTML preprocessor. So, at the moment you could transform:

  - JavaScript, JSON, YAML, CSS to CSS
  - JavaScript, JSON, YAML to HTML

## Usage
```
	var api = Absurd();
	api.add({
		body: {
			marginTop: "20px",
			p: {
				color: "#000"
			}
		}
	});
	api.compile(function(err, css) {
		// use the compiled css
	});
```
## Official site, documentation and online compilator

[http://absurdjs.com/](http://absurdjs.com/)

## Contribution and feedback

* [Issues](https://github.com/krasimir/absurd/issues)
* IRC channel at freenode.net: #absurdjs

## Extended

Middleware
* [Grunt-Absurd](https://github.com/krasimir/grunt-absurd) Compile Absurd with the Grunt Javascript Task Runner
* [Gulp-Absurd](https://github.com/krasimir/gulp-absurd) Compile Absurd with the Gulp Streaming Build System
* [Broccoli-Absurd-Filter](https://github.com/Xulai/broccoli-absurd-filter) Compile 1 to 1 Absurd with the Broccoli Asset Pipeline

Seeds
* [Absurd-Express-Seed](https://github.com/Xulai/absurd-express-seed) An absurd express seed made from the seed generated by express-generator

Generators
* None avaliable yet

Mixins
* [AbsurdHat](https://github.com/carlos22/absurdhat) A proof of concept wrapper for the LessHat set of Mixins

Frameworks
* [DadaJS](https://github.com/stockholmux/dada-js) Go even more absurd with Array Zero Selectors, an inbuilt vocabulary and a grid system utilising PocketGrid

CMSs
* [Techy](https://github.com/krasimir/techy) Super-Simple Flat CMS utilising Markdown as the geeky way of writing articles

Misc
* AbsurdJS support for JS Transformers -  [jstransformer-absurd](https://github.com/jstransformers/jstransformer-absurd) by [Charlike Mike Reagent](https://github.com/tunnckoCore)

## Contributors

* [Krasimir Tsonev](https://github.com/krasimir) Creator of AbsurdJS
* [RayoGundead](https://github.com/RayoGundead) 
* [Daniel Beauchamp](https://github.com/Xulai) 
* [Matias Lescano](https://github.com/mjlescano)
* [Volkan Altınbaş](https://github.com/valtinbas)
* [John-David Dalton](https://github.com/jdalton)
* [Jazblueful](https://github.com/jazblueful)

## Resources

  - AbsurdJS fundamentals - [link](http://krasimirtsonev.com/blog/article/AbsurdJS-fundamentals)
  - Writing your CSS with JavaScript - [link](http://davidwalsh.name/write-css-javascript)
  - Componentizing the Web - [link](http://code.tutsplus.com/tutorials/componentizing-the-web--cms-20602)

## Who's Using Absurd?

* [Crimasi](https://github.com/Crimasi) - [Ascend-Web](https://github.com/Crimasi/Ascend-Web)

